package vue;

import javax.swing.*;
import java.awt.*;

/**
 * La classe vue.FenetreConnexion permettant de se connecter au serveur et avoir accès aux différentes parties
 *
 * @author Maeva Billaut
 * @version 1.0
 */
public class FenetreConnexion {
    private JList<Integer> listePartie;
    private JList<String> listeStringPartie;

    private JTextField textLogin;

    private Integer gameId;

    private JButton boutonConnexion;
    private JButton boutonActualiser;
    private JButton boutonRejoindre;
    private JButton boutonCreer;

    private boolean creerPartie = false;

    public FenetreConnexion(String titre, String URL) {

        // Le JPanel principal
        JPanel principal = new JPanel();
        principal.setLayout(new BorderLayout());

        // Le JPanel connexion
        JPanel connexion = new JPanel();
        connexion.setLayout(new GridLayout(1,3));

        // Le JPanel login
        JPanel login = new JPanel();
        JLabel textelogin = new JLabel("Login : ");
        login.add(textelogin);
        textLogin = new JTextField();
        Dimension taille = new Dimension(300, 20);
        textLogin.setPreferredSize(taille);
        login.add(textLogin);
        login.setLayout(new FlowLayout(FlowLayout.LEFT));
        connexion.add(login);
        boutonConnexion = new JButton("Connexion");
        connexion.add(boutonConnexion);

        // Vue pour choisir une partie
        listePartie = new JList<>(new DefaultListModel<>());
        listeStringPartie = new JList<>(new DefaultListModel<>());
        getWaitingServer();
        //((DefaultListModel)listepartie.getModel()).addAll(client.waitingGames());
        JScrollPane panelListe = new JScrollPane(listeStringPartie);
        panelListe.setPreferredSize(new Dimension(200,300));
        principal.add(panelListe, BorderLayout.CENTER);

        JPanel panelBouton = new JPanel();
        panelBouton.setLayout(new GridLayout(1,3,60,0));
        boutonCreer = new JButton("creer Partie");
        panelBouton.add(boutonCreer);
        boutonRejoindre = new JButton("Rejoindre");
        panelBouton.add(boutonRejoindre);
        boutonActualiser = new JButton("Actualiser");
        panelBouton.add(boutonActualiser);
        principal.add(panelBouton, BorderLayout.SOUTH);

        //boutonActualiser.addActionListener(new ActualisationServeur(this));
        //listestringpartie.addListSelectionListener(new SelectionListeServeurControleur(this));
        //boutonRejoindre.addActionListener(new RejoindreControleur(this)); //get player
        //boutonCreer.addActionListener(new CreerPartieControleur(this)); //get player
        //boutonconnexion.addActionListener(new ConnexionPlayerControleur(this));

        boutonActualiser.setEnabled(false);
        boutonCreer.setEnabled(false);
        boutonRejoindre.setEnabled(false);
    }

    public Integer donneIndiceSelectionList() {
        return (Integer) ((DefaultListModel)listePartie.getModel()).get(listeStringPartie.getSelectedIndex());
    }

    public void getWaitingServer() throws CnNetworkException, CnBadIdException {
        if(!((DefaultListModel)listePartie.getModel()).isEmpty()) {
            ((DefaultListModel) listePartie.getModel()).removeAllElements();
            ((DefaultListModel)listeStringPartie.getModel()).removeAllElements();
        }

        ((DefaultListModel)listePartie.getModel()).addAll(client.waitingGames());
        for (int i = 0;i<((DefaultListModel)listePartie.getModel()).getSize();i++){
            ((DefaultListModel)listeStringPartie.getModel()).addElement("Partie n° "+ ((DefaultListModel)listePartie.getModel()).getElementAt(i)+" créé par "+client.consultGame((Integer) ((DefaultListModel)listePartie.getModel()).getElementAt(i)).creator());
        }

    }

    // Les getters
    public boolean getStatutActualiser(){

        return boutonActualiser.isEnabled();
    }

    public String getLogin(){
        return textLogin.getText();
    }

    public Integer getGameID(){
        return gameId;
    }

    public Boolean getCreerpartie() {
        return creerPartie;
    }

    // Les setters
    public void setGameID(Integer i){
        gameId = i;
    }

    public void setCreerpartie(Boolean bool) {
        creerPartie = bool;
    }

    // public void playerConnexion(Joueur pl) throws CnBadLoginException, CnNetworkException {
    //     player = pl;
    //     player.setPassword(client.addPlayer(player));
    //  }

    // Autres fonctions

    public void visibleCreer(){
        boutonCreer.setEnabled(true);
    }

    public void visibleRejoidre(){
        boutonRejoindre.setEnabled(true);
    }

    public void visibleActualiser(){
        boutonActualiser.setEnabled(true);
    }

    // public boolean rejoindre(Integer id, Joueur pl) throws CnNetworkException, CnBadLoginException, CnBadIdException {
    //     return client.joinGame(id,pl);
    // }
}
